# CalPro - Calculator and Plotting Library

CalPro is a Python library that provides a wide range of mathematical and plotting functionalities. With CalPro, you can perform various calculus operations, including integration, double integration, triple integration, and differentiation. You can also create 2D and 3D plots of functions, solve equations for unknown variables, and perform simple calculations.

## Installation

You can easily install CalPro using pip:

### pip install cal_pro

or 

### pip install cal_pro ==(version)



# Getting Started

Once installed, you can import the cal module from cal_pro to access its functions.

### from cal_pro import cal
<hr>

# Calculations

<ul><li>cal.integral_(): Calculate the integral of a function.</li>
<li>cal.definite_integral_(): Calculate the definite integral of a function.</li>
<li>cal.double_integral_(): Calculate the double integral of a function.</li>
<li>cal.triple_integral_():>cal.triple_integral_(): Calculate the triple integral of a function.</li>
<li>cal.deriviation(): Compute the derivative of a function.</li>
<li>cal.simple_cal(): Perform simple arithmetic calculations.</li>
<li>Equation Solving</li>
<li>cal.equation(): Solve equations for unknown variables.</li>
<li>Plotting</li>
<li>cal.plot_1(): Create 2D plots of a single function.</li>
<li>cal.plot_2(): Create 2D plots of multiple functions.</li>
<li>cal.plot_3(): Create 3D plots of functions.</li>
<li>cal.plot_x_y(): Create 2D plots of functions in the x-y plane.</li>
<li>cal.plot_x_z(): Create 2D plots of functions in the x-z plane.</li>
<li>cal.plot_y_z(): Create 2D plots of functions in the y-z plane.</li></ul>